Module Strings
    Public Function SysTok(ByVal sSrce As String, ByVal sDelim As String, ByVal Reset As Boolean) As String
        '
        '   Visual Basic implementation of the C function Systok(), modified by Apel 17.7.98
        '
        '   Input:
        '      sSrce$ - text string to be parsed
        '      sDelim - string of delimiter characters
        '      Reset  - True (first time), False (subsequent calls)
        '
        '   Function return:
        '      Next token, or "" if no more
        '
        '   Restrictions:
        '      Not reentrant.
        '      Tokens = "" will not be recognized!:
        '         "1,,2" can not be handled, because return value "" at
        '         2nd token will be interpreted as "no more token found".
        '      The original sSrce string will NOT be changed.
        '
        Dim i As Integer
        Dim j As Integer
        Dim s As String
        Static sSaveStr As String
        If Reset Then
            sSaveStr = sSrce
        End If

        If sSaveStr = "" Or sDelim = "" Then Return ""

        For i = 1 To Len(sSaveStr)
            If InStr(sDelim, Mid$(sSaveStr, i, 1)) > 0 Then
                s = Left$(sSaveStr, i - 1)
                sSaveStr = Mid$(sSaveStr, i + 1)
                GoTo Found
            End If

            If Mid$(sSaveStr, i, 1) = Chr(34) Then
                j = InStr(Mid$(sSaveStr, i + 1), Chr(34))
                If j > 0 Then
                    i = i + j
                End If
            End If
        Next i

        s = sSaveStr
        sSaveStr = ""

Found:
        If Len(s) > 1 And Left$(s, 1) = Chr(34) And Right$(s, 1) = Chr(34) Then
            s = Mid$(s, 2, Len(s) - 2)
        End If

NormalExit:
        'Aufrumen
        SysTok = s
        Exit Function
    End Function
End Module
